#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace DropDownFormAndUserControlSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(24, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(408, 296);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "Show";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 342);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "DropDown Form And UserControl Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// This sample implements two different custom cell controls.
			//
			// The first is a DropDownForm cell. This cell control drops
			// a Windows Forms Form holding a CheckedListBox and two buttons.
			// It behaves in a modal way, meaning the form captures the input
			// focus until the user explicitly closes it. This cell derives from 
			// GridDtaticCellRenderer and GridStaticCellModel.
			//
			// The second custom cell control is a DropDownUserControl cell.
			// This cell drops a UserControl holding a CheckedListBox and two
			// buttons. This cell ties into the grid's popup architecture to allow
			// the usercontrol to behave like a combobox in a modaless way. It does so
			// by being derived from GridDropDownCellRenderer and GridDropDownCellModel.


			// Here are the steps to use a custom user control.
			//1) Derive GridCellRendererBase and GridCellModelBase 
			//   classes that implement your custom cell control features.
			//   In this sample this is a cell control that shows a Windows
			//   Forms CheckListBox, as well as an OK and Cancel button. 
			//   The cell value consists of a comma separated list holding
			//   the checked options.
			//2) Register your custom cell type by adding an instance of the 
			//   GridCellModelBase derived class to the grid CellModels collection,
			//   passing a string that is used as the style.CellType value for
			//   for this custom cell type.
			//3) Set the style.CellType for the cells that you want to have this
			//   custom cell control.


			//2) Register your custom cell type
			this.gridControl1.CellModels.Add("DropDownForm", new DropDownFormCellModel(this.gridControl1.Model, new DropDownForm()));

			//3) Set the style.CellType for the cells
			this.gridControl1[2, 2].CellType = "DropDownForm";
			this.gridControl1[4, 2].CellType = "DropDownForm";
			
			//set other style properties...
			this.gridControl1[2, 2].Text = "choice1,choice3";
			this.gridControl1[2, 2].BackColor = Color.LightBlue;
			this.gridControl1[4, 2].Text = "choice2,choice5";
			this.gridControl1[4, 2].BackColor = Color.LightBlue;

			//2) Register your custom cell type
			this.gridControl1.CellModels.Add("DropDownUserControl", new DropDownUserCellModel(this.gridControl1.Model, new DropDownUser()));

			//3) Set the style.CellType for the cells
			this.gridControl1[6, 2].CellType = "DropDownUserControl";
			this.gridControl1[8, 2].CellType = "DropDownUserControl";
			
			//set other style properties...
			this.gridControl1[6, 2].Text = "choice1,choice3";
			this.gridControl1[6, 2].BackColor = Color.LightGoldenrodYellow;
			this.gridControl1[8, 2].Text = "choice2,choice5";
			this.gridControl1[8, 2].BackColor = Color.LightGoldenrodYellow;
			this.gridControl1[8, 2].ShowButtons = GridShowButtons.Hide;

			//set column width so can see the custom cells
			this.gridControl1.ColWidths[2] = 160;

		}
	}
}
